<template>
  <div>
    <form>
      <!-- Utilisateur -->
      <h3 class="line-header">
        <img
          src="@/assets/icons/face_user.svg"
          alt="Icône utilisateur"
        /> Utilisateur
      </h3>
      <ValidationObserver v-slot="{ handleSubmit }">
        <b-overlay
          :show="loading"
          :variant="'white'"
          :opacity="0.7"
          :blur="'2px'"
        >
          <div class="form-row">
            <div class="form-group col-6">
              <label>Statut</label>
              <Multiselect
                v-model="formData.status"
                :options="statusOptions"
                track-by="choice"
                label="label"
                selectLabel=""
                selectedLabel=""
                deselectLabel=""
                :searchable="false"
                placeholder="Statut"
                @select="changeStatus"
              />
            </div>
            <div class="form-group col-6">
              <label>{{ labelIdComp }}</label>
              <input
                v-model="formData.idComp"
                class="form-control"
                type="text"
              >
            </div>
          </div>
          <div class="form-row">
            <div class="form-group col-6">
              <label class="required">Nom</label>
              <ValidationProvider ref="last_name" rules="required" v-slot="{ classes, errors }">
                <div class="control" :class="classes">
                  <input
                    v-model="formData.lastName"
                    class="form-control"
                    type="text"
                    placeholder="Nom"
                  >
                  <span class="form-errors">{{ errors[0] }}</span>
                </div>
              </ValidationProvider>
            </div>
            <div class="form-group col-6">
              <label class="required">Prénom</label>
              <ValidationProvider ref="first_name" rules="required" v-slot="{ classes, errors }">
                <div class="control" :class="classes">
                  <input
                    v-model="formData.firstName"
                    class="form-control"
                    type="text"
                    placeholder="Prénom"
                  >
                  <span class="form-errors">{{ errors[0] }}</span>
                </div>
              </ValidationProvider>
            </div>
          </div>
          <div class="form-row">
            <div class="form-group col-12">
              <label>Motif de l'inscription</label>
              <textarea
                v-model="formData.comments"
                class="form-control"
                rows="1"
              />
            </div>
          </div>
          <div class="form-row">
            <div class="form-group col-6">
              <label class="required">Mail de l'utilisateur</label>
              <ValidationProvider ref="email" rules="required|email" v-slot="{ classes, errors }">
                <div class="control" :class="classes">
                  <input
                    v-model="formData.email"
                    class="form-control"
                    type="email"
                    placeholder="Mail de l'utilisateur"
                  >
                  <span class="form-errors">{{ errors[0] }}</span>
                </div>
              </ValidationProvider>
            </div>
            <div class="form-group col-6">
              <label>Téléphone de l'utilisateur</label>
              <ValidationProvider :rules="{ regex: /(?:(?:\+|00)33|0)\s*[1-9](?:[\s.-]*\d{2}){4}/}" v-slot="{ classes, errors }">
                  <div class="control" :class="classes">
                    <input
                      v-model="formData.tel"
                      class="form-control"
                      type="text"
                      placeholder="Téléphone de l'utilisateur"
                    >
                    <span class="form-errors">{{ errors[0] }}</span>
                  </div>
                </ValidationProvider>
            </div>
          </div>

          <span v-if="userError" class="form-errors">{{ userError }}</span>
          <div class="form-footer">
            <b-button
              variant="danger"
              @click="deleteUser"
            >
              Supprimer
            </b-button>
            <div>
              <b-button
                variant="outline-secondary"
                @click="$router.go(-1)"
              >
                Annuler
              </b-button>
              <b-button
                variant="primary"
                @click="handleSubmit(updateUser)"
              >
                Enregistrer les modifications
              </b-button>
            </div>
          </div>

        </b-overlay>
      </ValidationObserver>


      <!-- Organisation -->
      <h3 class="line-header">
        <img
          src="@/assets/icons/company.svg"
          alt="Icône organisation"
        /> Organisations
      </h3>
      <UserOrgForm
        v-for="organisation of organisations"
        :key="`org-${organisation.position}`"
        :usergroup="organisation"
        :userId="user.id"
        :mode="'edit'"
        @allowAdd="setCanAddOrganisation"
        @change="updateOrganisation"
        @delete="removeOrganisation"
      />
      <button
        class="add-button"
        :class="{
        disabled: !canAddOrganisation
      }"
        @click.prevent="addOrganisation"
      >
        <b-icon-plus />
        Ajouter une organisation
      </button>
      
      <!-- Groupe d'utilisateurs -->
      <h3 class="line-header">
        <img
          src="@/assets/icons/user-group.svg"
          alt="Icône organisation"
        /> Groupes d'utilisateurs
      </h3>
      <UserGroupForm
        v-for="group of groups"
        :key="`group-${group.position}`"
        :usergroup="group"
        :userId="user.id"
        :mode="'edit'"
        @allowAdd="setCanAddGroup"
        @change="updateGroup"
        @delete="removeGroup"
      />
      <button
        class="add-button"
        :class="{
        disabled: !canAddGroup
      }"
        @click.prevent="addGroup"
      >
        <b-icon-plus />
        Ajouter un groupe d'utilisateurs
      </button>
    </form>
  </div>
</template>

<script>
import UserOrgForm from '@/components/Forms/UserOrgForm.vue';
import UserGroupForm from '@/components/Forms/UserGroupForm.vue';
import Multiselect from 'vue-multiselect';

import { mapState, mapActions } from 'vuex';

// import Swal from "sweetalert2";
import "sweetalert2/dist/sweetalert2.min.css";

import { ValidationObserver, ValidationProvider, extend, configure } from 'vee-validate';
import { required, regex, email } from 'vee-validate/dist/rules';

extend('required', {
  ...required,
  message: 'Ce champ est requis'
});
extend('regex', {
  ...regex,
  message: 'Veuillez entrer un numéro de téléphone valide'
});
extend('email', {
  ...email,
  message: 'Veuillez entrer une adresse e-mail valide'
});
configure({
  classes: {
    valid: 'is-valid',
    invalid: 'is-invalid'
  }
});

const LABEL_ID_COMP = process.env.VUE_APP_LABEL_ID_COMP;

export default {
  name: 'UserForm',

  components: {
    UserOrgForm,
    UserGroupForm,
    Multiselect,
    ValidationObserver,
    ValidationProvider
  },

  props: {
    user: {
      type: Object,
      default: () => { return {} }
    },

    roles: {
      type: Array,
      default: () => { return [] }
    },

    loading: {
      type: Boolean,
      default: false
    }
  },

  data() {
    return {
      formData: {
        status: {
          choice: null,
          label: null
        },
        idComp: null,
        lastName: null,
        firstName: null,
        comments: null,
        email: null,
        tel: null
      },
      organisations: [],
      groups: [],
      canAddOrganisation: true,
      canAddGroup: true,
      statusOptions: [
        {
          choice: 0,
          label: 'Attente de vérification'
        },
        {
          choice: 1,
          label: 'Attente de validation'
        },
        {
          choice: 2,
          label: 'Actif'
        }
      ],
      labelIdComp: LABEL_ID_COMP
    }
  },

  computed: {
    ...mapState('users', [
      'userError',
      'currentUserRoles'
    ])
  },

  created() {
    this.formData.status.choice = this.user.status;
    this.formData.status.label = this.statusOptions.find(el => el.choice === this.user.status).label;
    this.formData.idComp = this.user.additional_id;
    this.formData.lastName = this.user.last_name;
    this.formData.firstName = this.user.first_name;
    this.formData.comments = this.user.comments;
    this.formData.email = this.user.email;
    this.formData.tel = this.user.phone_number;
    let orgPosition = 1;
    for (const organisation of this.roles.filter(el => el.usergroup.usergroup_type.codename === 'organisation')) {
      organisation.position = orgPosition;
      organisation.roleStatus = organisation.status;
      this.organisations.push(organisation);
      orgPosition += 1;
    }
    let groupPosition = 1;
    for (const group of this.roles.filter(el => el.usergroup.usergroup_type.codename === 'user-group')) {
      group.position = groupPosition;
      group.roleStatus = group.status;
      this.groups.push(group);
      groupPosition += 1;
    }
  },

  methods: {
    ...mapActions('users', [
      'GET_USER_DETAIL',
      'PATCH_USER',
      'REMOVE_USER_ROLE'
    ]),
    async changeStatus(e) {
      const data = { status: e.choice };
      this.busy = true;
      await this.PATCH_USER({ id: this.user.id, data: data });
      await this.GET_USER_DETAIL(this.currentOrganisation.id);
      this.busy = false;
    },

    setCanAddOrganisation(e) {
      this.canAddOrganisation = e;
    },

    addOrganisation() {
      const position = this.organisations.length + 1;
      this.organisations.push({
        position: position,
        role: null,
        roleStatus: null,
        usergroup: {}
      });
      this.canAddOrganisation = false;
    },

    updateOrganisation(e) {
      const index = this.organisations.findIndex(el => el.position === e.position);
      this.organisations[index] = {
        position: e.position,
        role: e.data.role,
        roleStatus: e.data.roleStatus,
        usergroup: e.data.organisation
      }
    },

    removeOrganisation(e) {
      const index = e - 1;
      this.organisations.splice(index, 1);
      this.canAddOrganisation = true;
    },

    setCanAddGroup(e) {
      this.canAddGroup = e;
    },

    addGroup() {
      const position = this.groups.length + 1;
      this.groups.push({
        position: position,
        role: null,
        roleStatus: null,
        usergroup: {}
      });
      this.canAddGroup = false;
    },

    updateGroup(e) {
      const index = this.groups.findIndex(el => el.position === e.position);
      this.groups[index] = {
        position: e.position,
        role: e.data.role,
        roleStatus: e.data.roleStatus,
        usergroup: e.data.group
      }
    },

    removeGroup(e) {
      const index = e - 1;
      this.groups.splice(index, 1);
      this.canAddGroup = true;
    },

    updateUser() {
      const updatedUser = {
        ...this.user,
        ...this.formData.idComp && {
          additional_id: this.formData.idComp
        },
        ...this.formData.firstName && {
          first_name: this.formData.firstName
        },
        ...this.formData.lastName && {
          last_name: this.formData.lastName
        },
        ...this.formData.comments && {
          comments: this.formData.comments
        },
        ...this.formData.email && {
          email: this.formData.email
        },
        ...this.formData.tel && {
          phone_number: this.formData.tel
        },
        ...this.formData.status.choice && {
          status: this.formData.status.choice
        },
      };
      this.$emit('save', updatedUser);
    },

    deleteUser() {
      this.$emit('delete');
    }
  }
}
</script>
